ll.registerPlugin(
    /* author */ "aabb",
    /* name */ "ms_show",
    /* introduction */ "显示延迟与丢包率and入服欢迎",
    /* version */ [1,5,0],
    /* otherInformation */ null
);

const timer = {};
const PATH = "./plugins/ms_show/data/PlayerInfo.json";
const configPATH = "./plugins/ms_show/config.json";

if (!file.exists(PATH)) {
    file.writeTo(PATH, '{}');
}

let playerData = JSON.parse(file.readFrom(PATH));

mc.listen("onChat", (player, msg) => {
    if (configDATA.get("Chat display") == 1) {
    mc.broadcast(`[${getcolor(player)}${player.getDevice().lastPing}ms§r]<${player.realName}> ${msg}`, 1);
    detect(player);
    return false;
    }
});

function getcolor(player) {
    const ping = player.getDevice().lastPing;
    return ping < 100 ? "§a" : (ping >= 100 && ping < 200 ? "§e" : "§c");
}

mc.listen("onServerStarted", () => {
    const cmd = mc.newCommand("ping", "查看延迟", PermType.Any);
    cmd.overload([]);
    cmd.setCallback((_cmd, ori, out, _res) => {
        const player = ori.player;
        player.tell("• §l>>             网络诊断             <<");
        dis(player);
    });
});

function showPingInfo(player, info) {
    player.tell(`• §e§l当前延迟 ： §a${info.lastPing} ms §7| §e平均延迟 ： §a${info.avgPing} ms`);
    player.tell(`• §e§l当前丢包率 ： §a${info.lastPacketLoss.toFixed(2)} % §7| §e平均丢包率： §a${info.avgPacketLoss.toFixed(2)} %`);
}

function dis(player) {
    const info = player.getDevice();
    player.tell(`• §l------------------------------------`);
    showPingInfo(player, info);
    player.tell(`• §l------------------------------------`);
}

function detect(player) {
    const info = player.getDevice();
    if (info.lastPing > 250) {
        if (timer[player.xuid] === undefined) {
            timer[player.xuid] = Math.floor(Date.now() / 1000);
        }
        const currentTime = Math.floor(Date.now() / 1000);
        if ((currentTime - timer[player.xuid]) > 300) {
            timer[player.xuid] = currentTime;
            player.tell(`• §l------------------------------------`);
            player.tell("• §c当前延迟较高可能会影响游戏体验，请尝试更换其它节点");
            showPingInfo(player, info);
            player.tell(`• §6使用/ping指令查看网络质量信息`);
            player.tell(`• §l------------------------------------`);
        }
    }
}

function PlayerJoinShowInfo(player) {
    let timeInfo = playerData[player.realName]?.TimeStamp;
    if (!timeInfo) {
        player.tell(`• §a§l冒险家 §r§e${player.realName} §l§b欢迎你首次来到这个大家庭！快开始你的探险之旅吧！`); //可以在此处更改首次加入欢迎语
        playerData[player.realName] = {
            JoinData: system.getTimeStr(),
            TimeStamp: Date.now()
        };
        player.tell("• §l>>           网络诊断           <<");
        dis(player);
        player.tell(`• §6使用/ping指令查看网络质量信息`);
    } else {
        let nowTime = Date.now();
        let timeDifference = nowTime - timeInfo;
        let showTime;
        if (timeDifference < 60 * 1000) {
            showTime = Math.floor(timeDifference / 1000) + " 秒";
        } else if (timeDifference < 60 * 60 * 1000) {
            showTime = Math.floor(timeDifference / 60000) + " 分钟";
        } else {
            showTime = (timeDifference / 3600000).toFixed(1) + " 小时";
        }
        player.tell(`• §a§l欢迎回来 §e${player.realName} §r§b你离开了 ${showTime}`); //可以在此处更改返回欢迎语
        player.tell("• §l>>             网络诊断             <<");
        dis(player);
        player.tell(`• §6使用/ping指令查看网络质量信息`);
        player.tell(`• §l§7上次的登录时间： ${playerData[player.realName].JoinData}`);
        playerData[player.realName].JoinData = system.getTimeStr();
        playerData[player.realName].TimeStamp = Date.now();
    }
    file.writeTo(PATH, JSON.stringify(playerData));
}

mc.listen("onLeft", (player) => {
    if (!player.isSimulatedPlayer()) {
        playerData[player.realName].TimeStamp = Date.now();
        file.writeTo(PATH, JSON.stringify(playerData));
    }
});

let configDATA;
if (file.exists(configPATH)) {
    configDATA = new JsonConfigFile(configPATH);
}

//生成配置文件，勿动！
mc.listen("onServerStarted", () => {
    if (file.exists(configPATH)) {
        colorLog("green", "配置文件已加载！")
        if (configDATA.get("Enable Welcome") == 1) {
            mc.listen("onJoin", (player) => {
                setTimeout(() => {
                    if (!player.isSimulatedPlayer()) {
                        PlayerJoinShowInfo(player)
                    }
                }, configDATA.get("Display latency"))
            })      
        }      
    } else {
        let configDATA = new JsonConfigFile(configPATH)
        configDATA.init("Display latency", 3000)
        configDATA.init("Chat display", 1)
        configDATA.init("Enable Welcome", 1)
        logger.info(`配置文件已生成，请前往${configPATH}修改.`)
    }
})
//生成配置文件，勿动！

mc.listen("onStartDestroyBlock", (player) => detect(player));
mc.listen("onPlaceBlock", (player) => detect(player));
mc.listen("onCloseContainer", (player) => detect(player));
mc.listen("onInventoryChange", (player) => detect(player));
